function irf=comp_irf(model,init,nrep,varargin)

MX  = model.mx;
ME  = model.me;
MY  = model.my;

nx  = size(MX,1);
I   = eye(size(ME,2));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                             %
% Impulse response functions                                                  %
%                                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RX      = zeros(nx,nrep);
if nargin>3
    RX(:,1) = ME*I(:,init)*varargin{1};
else
    RX(:,1) = ME*I(:,init);
end
for i=2:nrep+4;
    RX(:,i)	    = MX*RX(:,i-1);
end
RY      = (MY*RX)';     % Y_t
if isfield(model,'myf');
    nf      = length(model.myf);
    irf.yf  = cell(nf,1);
%     irf.ef  = cell(5,1);
    for i=1:nf
        
        RYF         = (model.myf{i}*RX)';
%         irf.ef{i}   = RY(i:(nrep+i-1),1)-RYF(1:nrep,1);
        irf.yf{i}   = RYF(1:nrep,:);
    end
end;
irf.x      = RX(:,1:nrep)';              % X_t
irf.y      = RY(1:nrep,:);
