function Vxi = vdecfreq(solution,wmin,wmax,select)

grid    = 512;
om      = 0:(2*pi)/grid:(2*pi*(1-0.5/grid));
T       = length(om);
gain    = zeros(T,1);
gain(and(om>=wmin,om<=wmax))=1;
gain(and(om>=(2*pi-wmax),om<=(2*pi-wmin)))=1;

nsel    = length(select);
if solution.id==0
    MX      = solution.mx;
    MY      = solution.my;
    ME      = solution.me;
    SIG     = solution.sig;
    SIGTr   = SIG;
    SIGTr(1,1)=0;
    ne      = size(ME,2);
    im      = sqrt(-1);
    r2pi    = 1/(2*pi);
    Totfilt = zeros(T,nsel*nsel);
    Trfilt  = zeros(T,nsel*nsel);
    for j=1:T;
        zi              = exp(-im*om(j));
        fom1            = MY(select,:)*((eye(length(MX))-MX*zi)\ME);
        fomT            = r2pi*(fom1*SIG*fom1');
        fomT            = gain(j)*fomT;
        Totfilt(j,:)    = fomT(:)';
        fomTr           = r2pi*(fom1*SIGTr*fom1');
        fomTr           = gain(j)*fomTr;
        Trfilt(j,:) 	= fomTr(:)';
    end
    ACVT    = 2*pi*real(ifft(Totfilt));
    COVT    = reshape(ACVT(1,:),nsel,nsel);
    VTOT    = diag(COVT)';
    ACVTR   = 2*pi*real(ifft(Trfilt));
    COVTr   = reshape(ACVTR(1,:),nsel,nsel);
    VTOTr   = diag(COVTr)';    
    Vxi     = 100*VTOTr./VTOT;
end
