addpath('method');
addpath('models');
rho         = 0.8;
K           = 12;
nchain      = 2;
NDraws      = 200000;
step        = 10;
nrep        = 20;
spmodel     = 'nk_model_utilization_ci_timing';
fpmodel     = 'real_model_utilization_ci_timing';

filemetro   = 'results/metro_nk_ci_timing_';
TH          = zeros(nchain*NDraws,25);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
TH  = TH(1:step:end,:);
nth = size(TH,1);
sels= [1:4 6:7];
nsel= length(sels);
IRF = zeros(nth,nsel*nrep);
TSY = zeros(nth,K+1);
TST = zeros(nth,K+1);
for i=1:nth
    sol = feval(spmodel,TH(i,:));
    tmp = comp_irf(sol,9,nrep);
    tmp = TH(i,14)*tmp.y(:,sels);
    IRF(i,:)=tmp(:)';
    
    GAMfX   = real(sol.gamfX);
    GAMfxi  = real(sol.gamfxi);
    GAMfz   = real(sol.gamfz);
    GAMfzb  = real(sol.gamfzb);
    OMX     = real(sol.omX);
    OMz     = real(sol.omz);
    OMzb    = real(sol.omzb);
    OMxi    = real(sol.omxi);
    DELT    = real(sol.delt);
    Q       = real(sol.q);
    
    sel     = 19; % Aggregate demand in Mf matrices
    nxf     = size(GAMfX,1);
    S       = zeros(nxf,K+1);
    tmp     = GAMfxi+(GAMfz+GAMfzb)*DELT;
    S(:,1)  = tmp(:,1);
    for k=1:K
        SUM = 0;
        for j=0:k-1
            SUM = SUM+OMX^(k-1-j)*((OMz+OMzb)*DELT+OMxi)*Q^j;
        end
        tmp     = (GAMfX*SUM+(GAMfxi+(GAMfz+GAMfzb)*DELT)*Q^k);
        S(:,k+1)= tmp(:,1);
    end
    TSY(i,:) = S(sel(1),:)*TH(i,14);
    nby      = 1;
    TST(i,:) = termstructot(sol,K,rho,TH(i,14),nby);
end
lspirf      = reshape(prctile(IRF,16)',nrep,nsel);
uspirf      = reshape(prctile(IRF,84)',nrep,nsel);
mspirf      = reshape(median(IRF)',nrep,nsel);
lsptsy      = reshape(prctile(TSY,16)',K+1,1);
usptsy      = reshape(prctile(TSY,84)',K+1,1);
msptsy      = reshape(median(TSY)',K+1,1);
lsptst      = reshape(prctile(TST,16)',K+1,1);
usptst      = reshape(prctile(TST,84)',K+1,1);
msptst      = reshape(median(TST)',K+1,1);
%%
filemetro   = 'results/metro_real_util_ci';
TH          = zeros(nchain*NDraws,19);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
TH  = TH(1:step:end,:);
nth = size(TH,1);
sels= [1:4];
nsel= length(sels);
IRF = zeros(nth,nsel*nrep);
TSY = zeros(nth,K+1);
TST = zeros(nth,K+1);
for i=1:nth
    sol = feval(fpmodel,TH(i,:));
    tmp = comp_irf(sol,8,nrep);
    tmp = TH(i,14)*tmp.y(:,sels);
    IRF(i,:)=tmp(:)';
    
    GAMfX   = real(sol.gamfX);
    GAMfxi  = real(sol.gamfxi);
    GAMfz   = real(sol.gamfz);
    GAMfzb  = real(sol.gamfzb);
    OMX     = real(sol.omX);
    OMz     = real(sol.omz);
    OMzb    = real(sol.omzb);
    OMxi    = real(sol.omxi);
    DELT    = real(sol.delt);
    Q       = real(sol.q);
    
    sel     = 10; % Aggregate Demand in Mf matrices
    nxf     = size(GAMfX,1);
    S       = zeros(nxf,K+1);
    tmp     = GAMfxi+(GAMfz+GAMfzb)*DELT;
    S(:,1)  = tmp(:,1);
    for k=1:K
        SUM = 0;
        for j=0:k-1
            SUM = SUM+OMX^(k-1-j)*((OMz+OMzb)*DELT+OMxi)*Q^j;
        end
        tmp     = (GAMfX*SUM+(GAMfxi+(GAMfz+GAMfzb)*DELT)*Q^k);
        S(:,k+1)= tmp(:,1);
    end
    TSY(i,:) = S(sel(1),:)*TH(i,14);
    nby      = 1;
    TST(i,:) = termstructot(sol,K,rho,TH(i,14),nby);
end
lfpirf      = reshape(prctile(IRF,16)',nrep,nsel);
ufpirf      = reshape(prctile(IRF,84)',nrep,nsel);
mfpirf      = reshape(median(IRF)',nrep,nsel);
lfptsy      = reshape(prctile(TSY,16)',K+1,1);
ufptsy      = reshape(prctile(TSY,84)',K+1,1);
mfptsy      = reshape(median(TSY)',K+1,1);
lfptst      = reshape(prctile(TST,16)',K+1,1);
ufptst      = reshape(prctile(TST,84)',K+1,1);
mfptst      = reshape(median(TST)',K+1,1);

%%
red         = [0.9216    0.5059    0.1059];
blue        = [0.0784    0.5529    0.9922];
green       = [0.0784    0.7412    0.5529];
gray        = [.85 .85 .85];
red         = [1 0 0];
blue        = [0 0 1];
fs          = 12;
fst         = 12;
str={'Output','Consumption','Investment','Hours Worked','Inflation','Nom. Int. Rate'};
X=(1:nrep)';
ylim=[0 1.25;0 1.25;-0.2 3.2;-0.2 1.25;0 1.25;0 1.25];
for i=1:6
    subplot(3,3,i);
%     hpatch  = patch([X;flipud(X)],[lspirf(:,i);flipud(uspirf(:,i))],gray);
%     set(hpatch,'linestyle','none')
%     hold on
    if i<=4
        h       =plot(X,[mspirf(:,i) mfpirf(:,i)]);
        set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
        set(h(2),'color',blue,'linewidth',1.2);
    else
        h       =plot(X,mspirf(:,i));
        set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
    end
    set(gca,'fontname','times','fontsize',fs,'xlim',[1 20],'ylim',ylim(i,:))
    if i==1
        ylabel('% dev.','fontname','times','fontsize',fs)
        o=legend('Flex. Price','Sticky Price','location','northeast')
        set(o,'fontname','times','fontsize',9,'box','off')
    end
    title(str{i},'fontname','times','fontsize',fst,'fontweight','normal')
    xlabel('Quarters','fontname','times','fontsize',fs)
    box on;
end
pause
printpdf('irf_est_xi');
close
return
%%
fs          = 12;
fst         = 12;
X=(1:12)';
X1=X+1;
subplot(2,2,1)
hpatch  = patch([X;flipud(X)],[lsptsy(X1);flipud(usptsy(X1))],gray);
set(hpatch,'linestyle','none')
hold on
h       =plot(X,[msptsy(X1) mfptsy(X1)]);
set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
set(h(2),'color',blue,'linewidth',1.2);
set(gca,'fontname','times','fontsize',fs,'xlim',[1 12],'ylim',[0 1.6])
box on
xlabel('Forecast Horizon in Quarters','fontname','times','fontsize',fs)
pause
printpdf('tsy_nkvsrbc');
close
%%
fs          = 12;
fst         = 12;
X=(1:12)';
X1=X+1;
subplot(2,2,1)
hpatch  = patch([X;flipud(X)],[lsptst(X1);flipud(usptst(X1))],gray);
set(hpatch,'linestyle','none')
hold on
h       =plot(X,[msptst(X1) mfptst(X1)]);
set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
set(h(2),'color',blue,'linewidth',1.2);
set(gca,'fontname','times','fontsize',fs,'xlim',[1 12],'ylim',[0 1.2])
box on
xlabel('Forecast Horizon in Quarters','fontname','times','fontsize',fs)
pause
printpdf('tstot_nkvsrbc');
close

%%
fs          = 12;
fst         = 14;
X=(1:12)';
X1=X+1;
subplot(2,2,1)
hpatch  = patch([X;flipud(X)],[lsptsy(X1);flipud(usptsy(X1))],gray);
set(hpatch,'linestyle','none')
hold on
h       =plot(X,[msptsy(X1) mfptsy(X1)]);
set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
set(h(2),'color',blue,'linewidth',1.2);
set(gca,'fontname','times','fontsize',fs,'xlim',[1 12],'ylim',[0 1.6])
box on
xlabel('Forecast Horizon in Quarters','fontname','times','fontsize',fs)
title('Aggregate Demand','fontname','times','fontsize',fst,'fontweight','normal')
subplot(2,2,2)
hpatch  = patch([X;flipud(X)],[lsptst(X1);flipud(usptst(X1))],gray);
set(hpatch,'linestyle','none')
hold on
h       =plot(X,[msptst(X1) mfptst(X1)]);
set(h(1),'color',red,'linewidth',1.2,'linestyle','--');
set(h(2),'color',blue,'linewidth',1.2);
set(gca,'fontname','times','fontsize',fs,'xlim',[1 12],'ylim',[0 1.2])
box on
xlabel('Forecast Horizon in Quarters','fontname','times','fontsize',fs)
title('Terms of Trade','fontname','times','fontsize',fst,'fontweight','normal')
pause
printpdf('ts_nkvsrbc');
close