
addpath('method');
addpath('models');

%%

nchain      = 2;
NDraws      = 200000;
step        = 10;
nrep        = 20;
spmodel     = 'nk_model_utilization_ci_timing';
fpmodel     = 'real_model_utilization_ci_timing';


%%
filemetro   = 'results/metro_nk_ci_timing_';
TH          = zeros(nchain*NDraws,25);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
TH  = TH(1:step:end,:);
spth=median(TH)';
spth0=spth;
spth0(18:19)=1e-10;
solsp       = feval(spmodel,spth);
solsp0      = feval(spmodel,spth0);

filemetro   = 'results/metro_real_util_ci';
TH          = zeros(nchain*NDraws,19);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
TH  = TH(1:step:end,:);
fpth=median(TH)';
fpth0=fpth;
fpth0(18:19)=1e-10;
solfp       = feval(fpmodel,fpth);
solfp0      = feval(fpmodel,fpth0);


sh={'ap','an','at','ip','it','c','g','m','xi'};
isp=1:9;
ifp=[1:7 0 8];
sigsp=[7 9 8 10 11 12 13 25 14];
sigfp=[7 9 8 10 11 12 13 14 14];
selsp= [1:4 6 7];
selfp= 1:4;

red         = [0.9216    0.5059    0.1059];
blue        = [0.0784    0.5529    0.9922];
green       = [0.0784    0.7412    0.5529];
red         = [1 0 0];
blue        = [0 0 1];
%%
fs=7;
fst=9;

str={'Output','Consumption','Investment','Hours Worked','Inflation','Nom. Int. Rate'};
ylim=cell(9,1);
ylim{1}=[-0.25 1;-0.25 1;-0.25 1;-0.25 1;-0.03 0.01;-0.03 0.01];
ylim{2}=[-0.25 1.25;-0.25 1.25;-0.25 1.25;-0.25 1.25;-0.02 0.1;-0.02 0.1];
ylim{3}=[-0.5 0.25;-0.5 0.25;-0.5 0.25;-0.5 0.25;-0.1 0.01;-0.1 0.01];
ylim{4}=[-1 0.5;-1 0.5;-1 0.5;-1 0.5;-0.02 0.02;-0.02 0.02];
ylim{5}=[-0.2 0.6;-0.2 0.6;-0.2 2.5;-0.2 0.6;-0.01 0.1;-0.01 0.1];
ylim{6}=[-1 0.1;-1 0.1;-1 0.1;-1 0.1;-0.2 -0.025;-0.2 -0.025];
ylim{7}=[-0.25 0.4;-0.25 0.4;-0.25 0.4;-0.25 0.4;0 0.04;0 0.04];
ylim{8}=[-0.4 0.01;-0.4 0.01;-0.4 0.01;-0.4 0.01;-0.125 0.125;-0.125 0.125];
ylim{9}=[0 1.25;0 1.25;-0.2 3.2;-0.2 1.25;0 1.25;0 1.25];
for i=9
    irf = comp_irf(solsp,isp(i),nrep);
    Ys = spth(sigsp(i))*irf.y(:,selsp);
    irf = comp_irf(solsp0,isp(i),nrep);
    Ys0 = spth0(sigsp(i))*irf.y(:,selsp);
    if ifp(i)>0
        irf = comp_irf(solfp,ifp(i),nrep);
        Yf  = fpth(sigfp(i))*irf.y(:,selfp);
        irf = comp_irf(solfp0,ifp(i),nrep);
        Yf0 = fpth0(sigfp(i))*irf.y(:,selfp);
    end
    for j=1:6
        if and(ifp(i)>0,j<=4)
        Y=[Ys(:,j) Yf(:,j)];% Ys0(:,j) Yf0(:,j)];
        else
        Y=[Ys(:,j) NaN(nrep,1)];% Ys0(:,j) NaN(nrep,1)];
        end
        subplot(4,6,j);h=plot(Y);
        set(h(1),'color',red,'linewidth',1.2)
        set(h(2),'color',blue,'linewidth',1.2)
%         set(h(3),'color',red,'linewidth',1.2,'linestyle','--')
%         set(h(4),'color',blue,'linewidth',1.2,'linestyle','--')
            
        set(gca,'fontname','times','fontsize',fs,'ylim',ylim{i}(j,:))
        if j==1
            ylabel('% dev.','fontname','times','fontsize',fs)
        end
        if and(i==9,j==1)
%             leg=legend('Flex. Price','Sticky Price','location','northeast')
%             set(leg,'fontname','times','fontsize',8)
line([2 5],[1.1 1.1],'color',blue,'linewidth',1.2)
line([2 5],[0.9 0.9],'color',red,'linewidth',1.2)
text(6,1.1,'Flex. Price','fontname','times','fontsize',6)
text(6,0.9,'Sticky Price','fontname','times','fontsize',6)
        end
        title(str{j},'fontname','times','fontsize',fst,'fontweight','normal')
        xlabel('Quarters','fontname','times','fontsize',fs)
    end
    pause
    printpdf(strcat('irf_theo_',sh{i}));
%     close
end
