function [IRF,VDEC,E,S,C1]=compirf_basic3(res,nrep,varargin)
p = inputParser;
addRequired(p,'res',@isstruct);
addRequired(p,'nrep',@isnumeric);

maxiter = 1000;
addParamValue(p,'maxiter',maxiter,@isnumeric);

parse(p,res,nrep,varargin{:});

lags    = res.lags;
nvar    = res.nvar;

SS      = eye(nvar);
C1      = zeros(nvar,nvar);
C2      = zeros(nvar,nvar);
nx      = size(res.mx,1);
% M       = [eye(nx)+res.mx+[res.mc*res.vc' zeros(nx,nvar*(lags-1))] -res.mx;eye(nx) zeros(nx)];
for i=1:nvar
    Y1      = [SS(:,i);zeros(nvar*(2*lags-1),1)];
    crit    = 1;
    tol     = 1e-9;
    lb      = 1;
    iter    = 1;
    while and(crit>tol,iter<=p.Results.maxiter)
        Y10     = res.mx*Y1;
        crit    = norm(Y10-Y1,inf);
        Y1      = lb*Y10+(1-lb)*Y1;
        iter    = iter+1;
    end
    C1(:,i) = Y1(1:nvar);
end

g1      =-C1(1,3)/C1(1,2);
s11     = sqrt(res.sigma(1,1));
s21     = res.sigma(1,2)/s11;
s31     = res.sigma(1,3)/s11;
g2      = res.sigma(2,3)-g1*res.sigma(3,3)-s31*(s21-g1*s31);
g2      = g2/(res.sigma(2,2)-g1*res.sigma(2,3)-s21*(s21-g1*s31));
s22     = sqrt((res.sigma(2,2)-s21*s21-g1*(res.sigma(2,3)-s31*s21))/(1-g1*g2));
s33     = sqrt((res.sigma(2,3)-s31*s21-g2*s22*s22)/g1);
s32     = g2*s22;
s23     = g1*s33;
S       = [s11 0 0;s21 s22 s23;s31 s32 s33];

E       = (S\res.resid')';
I       = eye(nvar);

SUM     = 0;
IRF     = cell(nvar,1);
C2IRF   = cell(nvar,1);
VDEC    = cell(nvar,1);
for i=1:nvar
    IRF{i}  = zeros(nrep,nvar);
    Y1      = [S(:,i);zeros(nvar*(2*lags-1),1)];
    IRF{i}(1,:)= Y1(1:nvar)';
    for t=2:nrep
        Y1      = res.mx*Y1;
        IRF{i}(t,:)= Y1(1:nvar)';
    end
    C2IRF{i}= cumsum(IRF{i}.*IRF{i});
    SUM     = SUM+C2IRF{i};
end


for i=1:3
    VDEC{i} = 100*C2IRF{i}./SUM;
end
if iter>p.Results.maxiter
    for i=1:3
        IRF{i}  = NaN(nrep,nvar);
        VDEC{i}  = NaN(nrep,nvar);
    end
end
