function [outy,outdy]=corrdyerr(sol)
%%
rng(1234567890,'twister');
nsim        = 100;
init        = 100;
T           = 160;
long        = init+T;
smpl        = init+1:long;
cory        = 0;
cordy       = 0;
stdy        = 0;
stddy       = 0;
acy         = 0;
acdy        = 0;
ne          = size(sol.me,2);
for s=1:nsim;
    ES      = diag(sqrt(diag(sol.sig)))*randn(ne,long);
    sim     = comp_data(sol,ES);    
    dy      = sim.y(smpl,1)-sim.y(smpl-1,1);
    dyf0t   = sim.yf{1}(smpl,1)-sim.y(smpl-1,1);
    dyf0    = sim.yf{1}(smpl,1)-sim.yf{1}(smpl-1,1);
    dyf1    = sim.yf{2}(smpl,1)-sim.yf{1}(smpl,1);
    dyf2    = sim.yf{3}(smpl,1)-sim.yf{2}(smpl,1);
    dyf3    = sim.yf{4}(smpl,1)-sim.yf{3}(smpl,1);
    dyf4    = sim.yf{5}(smpl,1)-sim.yf{4}(smpl,1);
    edy0t   = dy(1:T)-dyf0t(1:T);
    edy0    = dy(1:T)-dyf0(1:T);
    edy1    = dy(2:T)-dyf1(1:T-1);
    edy2    = dy(3:T)-dyf2(1:T-2);
    edy3    = dy(4:T)-dyf3(1:T-3);
    edy4    = dy(5:T)-dyf4(1:T-4);
    stddy   = stddy+[std(edy0t);std(edy0);std(edy1);std(edy2);std(edy3);std(edy4)]/nsim;
    ac0t    = autocorr(edy0t,4);
    ac0     = autocorr(edy0,4);
    ac1     = autocorr(edy1,4);
    ac2     = autocorr(edy2,4);
    ac3     = autocorr(edy3,4);
    ac4     = autocorr(edy4,4);
    acdy    = acdy+[ac0t.ac(1);ac0.ac(1);ac1.ac(1);ac2.ac(1);ac3.ac(1);ac4.ac(1)]/nsim;
    tmp     = corrcoef(edy0t,dy(1:T));
    cdy0t   = tmp(1,2);
    tmp     = corrcoef(edy0,dy(1:T));
    cdy0    = tmp(1,2);
    tmp     = corrcoef(edy1,dy(1:T-1));
    cdy1    = tmp(1,2);
    tmp     = corrcoef(edy2,dy(1:T-2));
    cdy2    = tmp(1,2);
    tmp     = corrcoef(edy3,dy(1:T-3));
    cdy3    = tmp(1,2);
    tmp     = corrcoef(edy4,dy(1:T-4));
    cdy4    = tmp(1,2);
    cordy   = cordy+[cdy0t;cdy0;cdy1;cdy2;cdy3;cdy4]/nsim;
        
    ey0     = sim.y(1:T,1)-sim.yf{1}(1:T,1);
    ey1     = sim.y(2:T,1)-sim.yf{2}(1:T-1,1);
    ey2     = sim.y(3:T,1)-sim.yf{3}(1:T-2,1);
    ey3     = sim.y(4:T,1)-sim.yf{4}(1:T-3,1);
    ey4     = sim.y(5:T,1)-sim.yf{5}(1:T-4,1);
    stdy    = stdy+[std(ey0);std(ey1);std(ey2);std(ey3);std(ey4)]/nsim;
    ac0     = autocorr(ey0,4);
    ac1     = autocorr(ey1,4);
    ac2     = autocorr(ey2,4);
    ac3     = autocorr(ey3,4);
    ac4     = autocorr(ey4,4);
    acy     = acy+[ac0.ac(1);ac1.ac(1);ac2.ac(1);ac3.ac(1);ac4.ac(1)]/nsim;
    tmp     = corrcoef(ey0,sim.y(1:T,1));
    cy0     = tmp(1,2);
    tmp     = corrcoef(ey1,sim.y(1:T-1,1));
    cy1     = tmp(1,2);
    tmp     = corrcoef(ey2,sim.y(1:T-2,1));
    cy2     = tmp(1,2);
    tmp     = corrcoef(ey3,sim.y(1:T-3,1));
    cy3     = tmp(1,2);
    tmp     = corrcoef(ey4,sim.y(1:T-4,1));
    cy4     = tmp(1,2);
    cory    = cory+[cy0;cy1;cy2;cy3;cy4]/nsim;
   
    
end
outy        = [stdy;cory;acy];
outdy       = [stddy;cordy;acdy];
