function densplot(priors,rangep,posterior,range);

kern    = 'knorm';
nbx     = 512;
h       = 0;
if nargin<3;
    [x,y]   = kdens(posterior,kern,nbx,h);
else
    [x,y]   = kdens(posterior,kern,nbx,h,range);
end

xx      = linspace(priors.mean-3*priors.std,priors.mean+3*priors.std,nbx);
switch upper(char(priors.type));
    case 'GAMMA'
        xx      = linspace(rangep(1),rangep(2),nbx);
        I       = find((xx<0));
        xx(I)   = 0;
        a       = priors.mean*priors.mean/(priors.std*priors.std);
        b       = priors.std*priors.std/priors.mean;
        fprior  = exp(lpdfgam(xx,a,b));
    case 'BETA'
        xx      = linspace(rangep(1),rangep(2),nbx);
        I       = find((xx<0)&(xx>1));
        xx(I)   = 0;
        a       = (1-priors.mean)*priors.mean*priors.mean/(priors.std*priors.std)-priors.mean;
        b       = a*(1/priors.mean-1);
        fprior  = exp(lpdfbeta(xx,a,b));
    case 'INVGAMMA'
        xx      = linspace(rangep(1),rangep(2),nbx);
        I       = find((xx<0));
        xx(I)   = 0;
%         if isinf(priors.std)
%             b   = 4;
%         else
%             b   = 2*(2+priors.mean*priors.mean/(priors.std*priors.std));
%         end
%         a       = sqrt(priors.mean*(b-2)/b);
               a       = priors.mean;
               b       = priors.std;
        fprior  = exp(lpdfig(xx,a,b));
        case 'UNIFORM'
            a       = priors.mean;
            b       = priors.std;
            xx      = linspace(rangep(1),rangep(2),nbx);
            fprior  = ones(size(xx(:),1),1)/(b-a);
    otherwise
        xx      = linspace(rangep(1),rangep(2),nbx);
        fprior  = exp(lpdfnor(xx,priors.mean,priors.std));
end

fs      = 12;
h       = plot(xx,fprior,x,y);
set(h(1),'color','k','linewidth',2,'linestyle','--');
set(h(2),'color','k','linewidth',2);
%legend('Prior','Posterior')
set(gca,'fontname','times','fontsize',fs);
