function graph_shocks_mode(model,data,TH,file,idx)
data_confidence;
load('../beliefs_july2016/datatomatch/data_for_estimation');
switch model.level
    case 1
        sol     = feval(model.name,TH,0);
    otherwise
        sol     = feval(model.name,TH);
end
sol.my  = sol.my(model.select,:);
ks      = kalman_smoother(data,sol);

T0      = 1960;
T1      = 2007.75;
tfpdat  = detrend(ltfpu,1);
mcidat  = standardize(conf);
tfpmod  = detrend((ks.x(:,idx(1))+ks.x(:,idx(1)+2))/100,0);
mcimod  = standardize(ks.x(:,idx(2)));
if model.level==0
    T0      = 1960.25;
    tfpdat  = tfpdat(2:end);
    mcidat  = mcidat(2:end);
end
subplot(221);plot(1980,0);%set(gca,'xlim',[1960 2007.75],'ylim',[-0.125 0.125])
set(gca,'xlim',[1960 2007.75]);%,'ylim',[-0.2 0.2])
hold on;
% Y=standardize(bpass([tfpmod tfpdat],6,32));
Y=standardize([tfpmod tfpdat]);
h=plot_nber(Y,T0,T1);
tmp=corrcoef(Y);
title(sprintf('corr=%6.2f',tmp(1,2)))

set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Technology Shock','Adj. Solow Res.','location','NorthEast');
set(o,'fontname','times','fontsize',10)
hold off
subplot(222);plot(1980,0);set(gca,'xlim',[1960 2007.75],'ylim',[-4 4]);hold on
% Y=standardize(bpass([mcimod mcidat],6,32));
Y=standardize([mcimod mcidat]);
h=plot_nber(Y,T0,T1);
tmp=corrcoef(Y);
title(sprintf('corr=%6.2f',tmp(1,2)))
set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Belief Shock','Consumer Confidence','location','NorthWest');
set(o,'fontname','times','fontsize',10)
hold off
pause
% printpdf(file);
close
return
sol         = feval([model.name '_mci'],TH,21);
y1q         = (sol.myf{2}(1,:)*ks.x')';
y1y         = (sol.myf{5}(1,:)*ks.x')';
y5y         = (sol.myf{21}(1,:)*ks.x')';
mci         = standardize(y1q+y1y+y5y);

subplot(221);plot(1980,0);%set(gca,'xlim',[1960 2007.75],'ylim',[-0.125 0.125])
set(gca,'xlim',[1960 2007.75],'ylim',[-0.2 0.2])
hold on;
h=plot_nber([tfpmod tfpdat],T0,T1);
set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Technology Shock','Adj. Solow Res.','location','NorthEast');
set(o,'fontname','times','fontsize',10)
hold off
subplot(222);plot(1980,0);set(gca,'xlim',[1960 2007.75],'ylim',[-4 4]);hold on
h=plot_nber([mci mcidat],T0,T1);
set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Model Cons. Conf. Index','Cons. Conf. Index','location','NorthWest');
set(o,'fontname','times','fontsize',10)
hold off
pause
printpdf([file '_mci']);
close
