function x = hpci(Y,alpha)
%
% hpci(Y,alpha) computes the (1-aalpha)-percent
%               hightest probability credible interval
%               of a vector of points Y
%
% x . . . . . . interval bounds
%
% Klaus Neusser, Bern, 27.10.2006
%
[F,X] = ecdf(Y); % empirical cumulative density function
%starting values
x0 = [X(floor(alpha/2*size(X,1))); X(ceil((1-alpha/2)*size(X,1)))];
% x0 = [X(floor(0.01*size(X,1))); X(ceil(0.9999*size(X,1)))];
% x0 = [X(2); X(end-1)];
%optimization
options = optimset('LargeScale','off','MaxFunEvals',1e9,'MaxIter',1e9,'Diagnostics','off','Display','iter');
x = fmincon(inline('(x(2)-x(1))*(x(2)-x(1))'),x0,[1 -1],[0],[],[],[X(1);X(1)],[X(end);X(end)],@(x)coveragecon(x,F,X,alpha),options);