function irf_model(TH,model,step,file,nom_)
nrep    = 20;
T       = size(TH,1);
ith     = 1:step:T;
TH      = TH(ith,:);
N       = length(ith);
str     = {'Output','Consumption','Investment','Hours Worked','Inflation Rate','Nominal Interest Rate'};
ne      = length(model.sh);

if nom_
    idx     = 1:6;
    ya      = zeros(N,nrep);
    ca      = zeros(N,nrep);
    ia      = zeros(N,nrep);
    ha      = zeros(N,nrep);
    pa      = zeros(N,nrep);
    ra      = zeros(N,nrep);
    for i=1:ne
        for s=1:N
            sol     = feval(model.name,TH(s,:));
            irf     = comp_irf(sol,model.ish(i),nrep,sqrt(sol.sig(model.ish(i),model.ish(i))));
            irf.y   = irf.y.*(abs(irf.y)>1e-6);
            ya(s,:)  = irf.y(:,idx(1))';
            ca(s,:)  = irf.y(:,idx(2))';
            ia(s,:)  = irf.y(:,idx(3))';
            ha(s,:)  = irf.y(:,idx(4))';
            pa(s,:)  = irf.y(:,idx(5))';
            ra(s,:)  = irf.y(:,idx(6))';
        end
        fs=12;
        gray=0.75*ones(1,3);
        pct=[33.33 50 66.66];
        
        x=(1:nrep)';
        y=ya;ci=prctile(y,pct)';
        subplot(231);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{1},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ca;ci=prctile(y,pct)';
        subplot(232);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{2},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ia;ci=prctile(y,pct)';
        subplot(233);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{3},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ha;ci=prctile(y,pct)';
        subplot(234);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{4},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=pa;ci=prctile(y,pct)';
        subplot(235);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{5},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ra;ci=prctile(y,pct)';
        subplot(236);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{6},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        printpdf(sprintf('%s_%s',file,model.sh{i}));
        close
    end
    
else
    idx     = 1:4;    
    ya      = zeros(N,nrep);
    ca      = zeros(N,nrep);
    ia      = zeros(N,nrep);
    ha      = zeros(N,nrep);    
    for i=1:ne
        for s=1:N
            sol     = feval(model.name,TH(s,:));
            irf     = comp_irf(sol,model.ish(i),nrep,sqrt(sol.sig(model.ish(i),model.ish(i))));
            irf.y   = irf.y.*(abs(irf.y)>1e-6);
            ya(s,:)  = irf.y(:,idx(1))';
            ca(s,:)  = irf.y(:,idx(2))';
            ia(s,:)  = irf.y(:,idx(3))';
            ha(s,:)  = irf.y(:,idx(4))';
        end
        fs=12;
        gray=0.75*ones(1,3);
        pct=[33.33 50 66.66];
        
        x=(1:nrep)';
        y=ya;ci=prctile(y,pct)';
        subplot(241);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{1},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ca;ci=prctile(y,pct)';
        subplot(242);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{2},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ia;ci=prctile(y,pct)';
        subplot(243);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{3},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        y=ha;ci=prctile(y,pct)';
        subplot(244);irfband(x, ci(:,2), ci(:,1), ci(:,3),gray,'k');
        title(str{4},'fontname','times','fontsize',fs);
        xlabel('Quarters','fontname','times','fontsize',fs);
        set(gca,'fontname','times','fontsize',fs);
        
        printpdf(sprintf('%s_%s',file,model.sh{i}));
        close
    end
end