function [shatnew,signew,loglh]=kfilter(y,H,C,F,shat,sig,R,Q)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MODEL
% y(t)=C+H*s(t)+e(t)
% s(t)=F*s(t-1)+v(t)
% V(e(t))=R
% V(v(t))=Q
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=length(y);
omega=F*sig*F'+Q;
omega=(omega+omega')/2;
sigma=H*omega*H'+R;
sigma=(sigma+sigma')/2;
isig=sigma\eye(size(sigma,1));
k=omega*H'*isig;

shatnew=F*shat+k*(y-C-H*F*shat);
signew=omega-k*H*omega;

loglh=-.5*log(det(sigma))-.5*(y-C-H*F*shat)'*isig*(y-C-H*F*shat)-.5*n*log(2*pi);
