function marg_data_dens=marg_density(theta,p_theta,step)
[sdraws,nth]    = size(theta);
p_theta         = p_theta(1:step:sdraws,:);
theta           = theta(1:step:sdraws,:);
[sdraws,ncoef]  = size(theta);                      % length of the simulated estimates

theta_mean      = mean(theta);                      % mean
theta_var       = cov(theta);                       % covariance matrix

tolvar          = 1e-6;
i               = find(diag(theta_var)<tolvar);
theta_var(i,i)  = tolvar;
[L,U]           = lu(theta_var);    % LU representation of theta_var
ITV             = inv(U)*inv(L);    % Accurate computation of inverse of Sigma
% posterior marginal densities obtained by
% Geweke Harmonic Mean Estimator
%------------------------------
p               = (0.1:0.1:0.9)';   % truncation parameter
pcrit           = chis_inv(p,ncoef);
np              = size(p,1);
hmax            = 2;
suminvlike      = zeros(np,1);
laginvlike      = zeros(hmax,np);
gaminvlike      = zeros(hmax,np);

% truncated multivariate normal distribution for harmonic mean (geweke) estimate of marginal density
mp_theta        = mean(p_theta);
tmp             = -log(p)-0.5*nth*log(2*pi)-0.5*log(det(theta_var));
for i=1:sdraws
    tmp_th      = ((theta(i,:)-theta_mean)*ITV*(theta(i,:)-theta_mean)');
    lnf         = tmp-0.5*tmp_th;
    ind         = tmp_th<pcrit;     % truncation index
    invlike     = exp(lnf-(p_theta(i)-mp_theta)).*ind;
    laginvlike  = [invlike';laginvlike(1:hmax-1,:)];
    gaminvlike  = gaminvlike+laginvlike.*repmat(invlike',hmax,1);
    suminvlike  = suminvlike+invlike;
end
meaninvlike = suminvlike/sdraws;
gaminvlike  = gaminvlike/sdraws-repmat((meaninvlike.^2)',hmax,1);
marg_data_dens  = mp_theta-log(meaninvlike);
