function data=min_dist_shocks(sol,Y,sel)
T   = size(Y,1);

OM      = weightmat(Y,4);diag(diag(weightmat(Y,4)));
IS      = chol(OM)\eye(size(Y,2));
W       = kron(eye(T),IS*IS');

MX  = sol.mx;
ME  = sol.me;
MY  = sol.my(sel,:);
ne  = size(ME,2);
ny  = size(MY,1);
nx  = size(MX,1);
A   = zeros(ny*(T-1),nx);
tmp = MX;
for t=1:T
    A((t-1)*ny+1:t*ny,:)    = MY*tmp;
    tmp                     = tmp*MX;
end

B   = zeros(ny*T,ne*T);
tmp = eye(nx);
B0  = MY*tmp*ME;
for t=1:T
    B((t-1)*ny+1:t*ny,1:t*ne)=B0;
    tmp = tmp*MX;
    B0      = [MY*tmp*ME B0];
end

Y   = Y';
Y   = Y(:);
IAWA= (A'*W*A)\eye(nx);
tmp = W-(W*A)*IAWA*(A'*W);
E0  = B'*tmp*B;

E1  = B'*tmp*Y;
E   = E0\E1;
X0  = IAWA*(A'*W)*(Y-B*E);
E   = reshape(E,ne,T)';

Sh  = zeros(size(MX,1),T);
Sh(:,1)=MX*X0+ME*E(1,:)';
for t=2:T
    Sh(:,t)=MX*Sh(:,t-1,1)+ME*E(t,:)';
end
Sh  = Sh';

data.x  = Sh;
data.e  = E;

end

function W=weightmat(X,par_size)
%
% X series (TxN)
% par_size # of lags in the VAR
%
[rx,cx]	= size(X);
MX      = mean(X);
X		= X-kron(ones(rx,1),MX);
Y		= X(par_size+1:rx,:);
Y       = Y-repmat(mean(Y),rx-par_size,1);
XL		= [];
for i=1:par_size;
    XL	= [XL X(par_size-i+1:rx-i,:)];
end;
A			= [];
R			= [];
for i=1:cx;
    XL			= XL-repmat(mean(XL),rx-par_size,1);
    B		= XL\Y(:,i);
    A		= [A;B'];
    R		= [R Y(:,i)-XL*B];
end;
SA=0;
for i=1:par_size;
    SA		= SA+A(:,1+(i-1)*cx:i*cx);
end;
W			= inv(eye(cx)-SA)*cov(R)*inv(eye(cx)-SA)';
end