function model_vs_var(TH,model,fileres)
addpath('../method');
rng(1234567890,'twister');
theta   = mean(TH);
beta    = 0.99;
delta   = 0.015;
alpha   = theta(16);
mkup    = 0.15;
gsy     = 0.2;
ksy     = beta*alpha/((1+mkup)*(1-beta*(1-delta))); % Assumption: There exists a subsidy to get rid off the distorsions
isy     = delta*ksy;
csy     = 1-isy-gsy;

%%
%
% some file names
%
% alpha   = 0.3;
% b       = 1/(1-alpha);
sol     = feval(model.name,theta);
ne      = size(sol.me,2);
sely    = [3 4 7];
nlags   = 4;
nvar    = 3;
T       = 192;
init    = 200;
nrep    = 40;
nsim    = 100;
sgn     = 1;
sgc     = 1;
selv    = [1 4 8 20];
smpl    = (init+1):(T+init);
E       = randn(ne,T+init,nsim);
cst     = ones(T,1);
Yp      = 0;
Yn      = 0;
Yc      = 0;
Vp      = 0;
Vn      = 0;
Vc      = 0;

for s=1:nsim
    
    Sig     = chol(sol.sig)';
    u       = (Sig*E(:,:,s));
    X       = sol.me*u(:,1);
    Y       = zeros(T+init,3);
    Y(1,:)  = sol.my(sely,:)*X;
    for t=2:T+init
        X   = sol.mx*X+sol.me*u(:,t);
        Y(t,:)  = sol.my(sely,:)*X;
    end
    x       = Y(smpl,1);
    h       = Y(smpl,2);
    tfp     = Y(smpl,3);
    dtfp    = (Y(smpl,3)-Y(smpl-1,3));
    resrc   = ols(x,[cst tfp]);
    b       = resrc.beta(2);
    rc      = x-b*tfp; % cointegration from model
    Y       = [dtfp h rc];
    res     = varest(Y,nlags,1);
    A1      = 0;
    for i = 1:nlags;
        A1  = A1+res.dyn(:,(i-1)*nvar+1:i*nvar);
    end
    A1      = eye(nvar)-A1;
    [L,U]   = lu(A1);
    C1      = inv(U)*inv(L);
    g1      =-C1(1,3)/C1(1,2);
    s11     = sqrt(res.sigma(1,1));
    s21     = res.sigma(1,2)/s11;
    s31     = res.sigma(1,3)/s11;
    g2      = res.sigma(2,3)-g1*res.sigma(3,3)-s31*(s21-g1*s31);
    g2      = g2/(res.sigma(2,2)-g1*res.sigma(2,3)-s21*(s21-g1*s31));
    s22     = sqrt((res.sigma(2,2)-s21*s21-g1*(res.sigma(2,3)-s31*s21))/(1-g1*g2));
    s33     = sqrt((res.sigma(2,3)-s31*s21-g2*s22*s22)/g1);
    s32     = g2*s22;
    s23     = g1*s33;
    S       = [s11 0 0;s21 s22 s23;s31 s32 s33];
    I       = eye(nvar);
    mod.mx  = res.mx;
    mod.me  = [S;zeros(nvar*(nlags-1),nvar)];
    mod.my  = [I zeros(nvar,nvar*(nlags-1))];
    RYp     = comp_irfvar(mod,I(:,1),nrep);
    RYn     = comp_irfvar(mod,sgn*I(:,2),nrep);
    RYc     = comp_irfvar(mod,sgc*I(:,3),nrep);
    RYp(:,1)= cumsum(RYp(:,1));
    RYn(:,1)= cumsum(RYn(:,1));
    RYc(:,1)= cumsum(RYc(:,1));
    RYp(:,3)= RYp(:,3)+b*RYp(:,1);
    RYn(:,3)= RYn(:,3)+b*RYn(:,1);
    RYc(:,3)= RYc(:,3)+b*RYc(:,1);
    DYp     = cumsum(RYp.*RYp);
    DYn     = cumsum(RYn.*RYn);
    DYc     = cumsum(RYc.*RYc);
    tmp     = DYp+DYn+DYc;
    RVp     = 100*DYp(selv)./tmp(selv);
    RVn     = 100*DYn(selv)./tmp(selv);
    RVc     = 100*DYc(selv)./tmp(selv);
    Yp      = Yp+RYp/nsim;
    Yn      = Yn+RYn/nsim;
    Yc      = Yc+RYc/nsim;
    Vp      = Vp+RVp/nsim;
    Vn      = Vn+RVn/nsim;
    Vc      = Vc+RVc/nsim;
end;

load dat_basic_phi;

%%
YLIM    = [-0.25 0.25;-0.1 1.7;-0.5 3.75];
prt_    = 1;
QRTS    = (0:nrep-1)';
names   = {'Adjusted TFP','Hours Worked','Investment'};
fs      = 12;
for i=1:3
    subplot(2,3,i)
    irfplot(QRTS,[Y3c(1:nrep,i) Yc(1:nrep,i)],YMAX3c(1:nrep,i),YMIN3c(1:nrep,i),names(i),fs);
    %     if i==1;ylabel('Confidence Shock');end
%     set(gca,'ylim',YLIM(i,:));
end
% pause;
if prt_
    printpdf(strcat(fileres,'_conf'));
end
close;

%%
YLIM    = [0.5 1;-0.1 0.6;0.5 3]; % for Emm
YLIM    = [0.5 1.6;-0.5 0.5;0.5 3]; % for BMLE
for i=1:3
    subplot(2,3,i)
    irfplot(QRTS,[Y3p(1:nrep,i) Yp(1:nrep,i)],YMAX3p(1:nrep,i),YMIN3p(1:nrep,i),names(i),fs);
    %     if i==1;ylabel('Confidence Shock');end
%     set(gca,'ylim',YLIM(i,:));
end
% pause;
if prt_
    printpdf(strcat(fileres,'_perm'));
end
close;
%%

YLIM    = [-0.5 1.5;-0.75 0.75;-1 3.5];
for i=1:3
    subplot(2,3,i)
    irfplot(QRTS,[Y3n(1:nrep,i) Yn(1:nrep,i)],YMAX3n(1:nrep,i),YMIN3n(1:nrep,i),names(i),fs);
    %     if i==1;ylabel('Confidence Shock');end
%     set(gca,'ylim',YLIM(i,:));
end
% pause;
if prt_
    printpdf(strcat(fileres,'_news'));
end
close;
