function plotdist(file,nchain,latexnames,datapriors,bounds)
idx = 1:11;%[1 6 7 2 3 4 5];
nbin= 20;
step= 10;
fs  = 12;
TH  = [];
for i=1:nchain
    load([file.folder '/' file.metro int2str(i)])
    TH=[TH;theta];
end
[T,nparest] = size(TH);
ith = 1:step:T;
TH          = TH(ith,:);
k=1;
fig=1;
for i=1:nparest
    
    strtit  = latexnames{idx(i)};
    type    = datapriors.type{idx(i)};
    a       = datapriors.mean(idx(i));
    b       = datapriors.std(idx(i));
    
    thmin   = max(min(TH(:,idx(i))),bounds(idx(i),1));
    thmax   = min(max(TH(:,idx(i))),bounds(idx(i),2));
    avth    = mean(TH(:,idx(i)));
    mdth    = median(TH(:,idx(i)));
    x       = linspace(thmin,thmax,500);
    switch type
        case 'gamma'
            y=exp(lpdfgam(x,a,b));
        case 'invig'
            y=exp(lpdfgam(x,a,b));
        case 'uniform'
            y=1/(b-a);
        case 'beta'
            y=exp(lpdfbeta(x,a,b));
        otherwise
            y=exp(lpdfnorm(x,a,b));
    end
    [F,X]   = hist(TH(:,idx(i)),nbin);
    F       = F/(sum(F)*(X(2)-X(1)));
    subplot(3,3,k);
    h1      = bar(X,F);
    hold on
    h2      = plot(x,y);
    set(h1,'edgecolor','k','facecolor',0.7*ones(1,3),'barwidth',0.85);
    set(h2,'linewidth',2,'color','r');
    title(strtit,'fontname','times','fontsize',fs)
    set(gca,'fontname','times','fontsize',fs,'xlim',[x(1) x(500)])
    ylim=get(gca,'ylim');
    h2=line(avth*ones(1,2),ylim);set(h2,'linewidth',1.2,'color','k');
    h3=line(mdth*ones(1,2),ylim);set(h3,'linewidth',1.2,'color','k','linestyle','--');
    if or(rem(k,9)==0,i==nparest)
        k=1;
        printpdf(strcat(file.folder,'/post_',file.metro,'_',int2str(fig)))
        close
        fig=fig+1;
    else
        k=k+1;
    end
end