function smooth=shock_kalman(param,model,step,fixed,ith,ifix,file,ia,ixi)

load(file);
ly          = detrend(ly,0);
wdg         = (wedge1-mean(wedge1))/std(wedge1);
lh          = detrend(lh,0);
ltfp        = detrend(ltfp,0);
ltfpu       = detrend(ltfpu,0);
T           = length(ly);
data_confidence;
cf          = detrend(conf,0)/std(conf);

[N,npar]    = size(param);
nfix        = size(fixed(:),1);
idth        = 1:step:N;
N           = length(idth);
ayh         = zeros(N,T);
byh         = zeros(N,T);
aph         = zeros(N,T);
bph         = zeros(N,T);
ayp         = zeros(N,T);
byp         = zeros(N,T);

th          = zeros(npar+nfix,1);
th(ifix)    = fixed(:);
for i=1:N
    th(ith) = param(idth(i),:)';
    sol     = feval(model.name,th);
    solh    = sol;
    solh.my = solh.my([1 4],:);
    tmp     = kalman_smoother([ly,lh],solh);
    ayh(i,:)= tmp.x(:,ia);
    byh(i,:)= detrend(tmp.x(:,ixi),0)/std(tmp.x(:,ixi));
    solh    = sol;
    solh.my = solh.my([8 4],:);
    tmp     = kalman_smoother([ltfp,lh],solh);
    aph(i,:)= tmp.x(:,ia);
    bph(i,:)= detrend(tmp.x(:,ixi),0)/std(tmp.x(:,ixi));
    solh    = sol;
    solh.my = solh.my([1 8],:);
    tmp     = kalman_smoother([ly,ltfp],solh);
    ayp(i,:)= tmp.x(:,ia);
    byp(i,:)= detrend(tmp.x(:,ixi),0)/std(tmp.x(:,ixi));
end
p1          = 100/3;
p2          = 100-p1;
mayh        = mean(ayh)';
mbyh        = mean(byh)';
maph        = mean(aph)';
mbph        = mean(bph)';
mayp        = mean(ayp)';
mbyp        = mean(byp)';

mdayh       = median(ayh)';
mdbyh       = median(byh)';
mdaph       = median(aph)';
mdbph       = median(bph)';
mdayp       = median(ayp)';
mdbyp       = median(byp)';

minayh      = prctile(ayh,p1)';
minbyh      = prctile(byh,p1)';
minaph      = prctile(aph,p1)';
minbph      = prctile(bph,p1)';
minayp      = prctile(ayp,p1)';
minbyp      = prctile(byp,p1)';

maxayh      = prctile(ayh,p2)';
maxbyh      = prctile(byh,p2)';
maxaph      = prctile(aph,p2)';
maxbph      = prctile(bph,p2)';
maxayp      = prctile(ayp,p2)';
maxbyp      = prctile(byp,p2)';

T0          = 1968.75;
T1          = 2007.75;
fs          = 12;
subplot(231);h=plot_nber([mayh ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbyh cf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbyh wdg],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_yh');
% end
close

subplot(231);h=plot_nber([maph ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbph cf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbph wdg],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_ph');
% end
close

subplot(231);h=plot_nber([mayp ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbyp cf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbyp wdg],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_yp');
% end
close


    res     = ols(cf,[ones(length(cf),1) ltfpu]);
    ycf     = (res.resid-mean(res.resid))/std(res.resid);
    res     = ols(wdg,[ones(length(cf),1) ltfpu]);
    ylw     = (res.resid-mean(res.resid))/std(res.resid);
 
subplot(231);h=plot_nber([mayh ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbyh ycf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbyh ylw],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_yh_purged');
% end
close

subplot(231);h=plot_nber([maph ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbph ycf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbph ylw],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_ph_purged');
% end
close

subplot(231);h=plot_nber([mayp ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Technology Shock','Adj. Solow Res.');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(232);h=plot_nber([mbyp ycf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)

subplot(233);h=plot_nber([mbyp ylw],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs)
o=legend(h,'Belief Shock','Consumer Confidence');%,'location','southwest')
set(o,'fontname','times','fontsize',8)
pause
% if prt_
printpdf('shocks_yp_purged');
% end
close    
    
    
smooth.ayh.mean     = mayh;
smooth.byh.mean     = mbyh;
smooth.aph.mean     = maph;
smooth.bph.mean     = mbph;

smooth.ayh.median   = mdayh;
smooth.byh.median   = mdbyh;
smooth.aph.median   = mdaph;
smooth.bph.median   = mdbph;

smooth.ayh.min      = minayh;
smooth.byh.min      = minbyh;
smooth.aph.min      = minaph;
smooth.bph.min      = minbph;

smooth.ayh.max      = maxayh;
smooth.byh.max      = maxbyh;
smooth.aph.max      = maxaph;
smooth.bph.max      = maxbph;