function S=smooth(I_w,window,bandwidth)
N=bandwidth;
switch lower(window)
    case 'hanning'
        wind=0.5*(1-cos(2*pi*(0:N-1)'/(N-1)));
    case 'hamming'
        a=0.54;
        wind=a-(1-a)*cos(2*pi*(0:N-1)'/(N-1));
    case 'blackman'
        a=0.16;
        wind=0.5*(1-a)-0.5*cos(2*pi*(0:N-1)'/(N-1))+0.5*a*cos(4*pi*(0:N-1)'/(N-1));
    case 'bartlett'
        wind=(2/(N-1))*((N-1)/2-abs((0:N-1)'-(N-1)/2));
    otherwise
        wind= ones(N,1);
end
k = round(N/2);
xb = I_w(1:k);            % First k elements
xt = I_w(end-k+1:end);    %  Last k elements
s = [flipud(xb); I_w; flipud(xt)];

S = conv(wind./sum(wind),s);
S = S(N+1:end-N);
end