function irfplot(X,Y,UP_Y,LW_Y,titre,fs,leg,varargin)
tt=0;
if nargin>4
    if ~isempty(titre);
        tt=1;
    end;
    if (nargin<6)|(isempty(fs));
        fs=14;
    end
end

col={'k','b','b','k'};
styl={'-','--','-','-'};
MS=[0.1 0.1 .04 5];
h=plot(X,Y);
for i=1:length(h);
    set(h(i),'linewidth',2,'color',char(col{i}),'linestyle',styl{i},'marker','o','markersize',MS(i),'markerfacecolor',char(col{i}),'markeredgecolor',char(col{i}));
end
if (nargin>6)
    if ~isempty(leg)
    [o,h]=legend(leg,'Location','NorthEast');
    %set(o(:),'interpreter','latex','fontname','times','fontsize',12)
    set(o(:),'fontname','times','fontsize',12)
    end
end
hpatch = patch([X;flipud(X)],[LW_Y;flipud(UP_Y)],[.85 .85 .85]); % gris Martialou
set(hpatch,'linestyle','none')
hold on
h=plot(X,Y);
for i=1:length(h);
    set(h(i),'linewidth',2,'color',char(col{i}),'linestyle',styl{i},'marker','o','markersize',MS(i),'markerfacecolor',char(col{i}),'markeredgecolor',char(col{i}));
end
[tmp,i] = max(abs(UP_Y));
limup   = max(max(UP_Y),1.05*tmp*sign(UP_Y(i)));
[tmp,i] = max(abs(LW_Y));
liminf  = min(min(LW_Y),1.05*tmp*sign(LW_Y(i)));
xlabel('Quarters','fontname','times','fontsize',fs)
set(gca,'Layer','top')
if nargin>7
    set(gca,'xlim',[X(1);X(end)],'ylim',varargin{1},'fontname','times','fontsize',fs)
else
    set(gca,'xlim',[X(1);X(end)],'ylim',sort([liminf limup]),'fontname','times','fontsize',fs)
end
% set(gca,'xlim',[X(1);X(end)],'fontname','times','fontsize',fs)
grid
if tt;
    title(titre,'fontname','times','fontsize',fs)
end
box on;
hold off;