function vdec_beliefs_model(TH,model,step,nom_)
nrep    = 40;
T       = size(TH,1);
ith     = 1:step:T;
TH      = TH(ith,:);
N       = length(ith);
pct     = 100/3;

sol = feval(model.name,TH(1,:));
ne  = size(sol.me,2);

if nom_
    idx     = 1:6;
    vy  = cell(ne,1);
    vc  = cell(ne,1);
    vx  = cell(ne,1);
    vh  = cell(ne,1);
    vp  = cell(ne,1);
    vr  = cell(ne,1);
    for i=1:ne
        vy{i}   = zeros(N,nrep);
        vc{i}   = zeros(N,nrep);
        vx{i}   = zeros(N,nrep);
        vh{i}   = zeros(N,nrep);
        vp{i}   = zeros(N,nrep);
        vr{i}   = zeros(N,nrep);
    end
    vty = zeros(N,nrep);
    vtc = zeros(N,nrep);
    vtx = zeros(N,nrep);
    vth = zeros(N,nrep);
    vtp = zeros(N,nrep);
    vtr = zeros(N,nrep);
    for s=1:N
        sol     = feval(model.name,TH(s,:));
        for i=1:ne
            irf     = comp_irf(sol,i,nrep,sqrt(sol.sig(i,i)));
            irf     = irf.y.*(abs(irf.y)>1e-6);
            vy{i}(s,:)  = cumsum(irf(:,idx(1)).*irf(:,idx(1)))';
            vty(s,:)    = vty(s,:)+vy{i}(s,:);
            vc{i}(s,:)  = cumsum(irf(:,idx(2)).*irf(:,idx(2)))';
            vtc(s,:)    = vtc(s,:)+vc{i}(s,:);
            vx{i}(s,:)  = cumsum(irf(:,idx(3)).*irf(:,idx(3)))';
            vtx(s,:)    = vtx(s,:)+vx{i}(s,:);
            vh{i}(s,:)  = cumsum(irf(:,idx(4)).*irf(:,idx(4)))';
            vth(s,:)    = vth(s,:)+vh{i}(s,:);
            vp{i}(s,:)  = cumsum(irf(:,idx(5)).*irf(:,idx(5)))';
            vtp(s,:)    = vtp(s,:)+vp{i}(s,:);
            vr{i}(s,:)  = cumsum(irf(:,idx(6)).*irf(:,idx(6)))';
            vtr(s,:)    = vtr(s,:)+vr{i}(s,:);
        end
    end
    sel=[1 4 8 20 40];
    nsel=length(sel);
    fmt1= ['%2d ' repmat('& %5.2f ',1,6) '\\\\ \n'];
    fmt2= [repmat('& {\\scriptsize [%5.2f;%5.2f]} ',1,6) '\\\\ \n'];
    disp('\begin{table}[htbp]')
    disp('\centering')
    disp('\caption{Variance Decomposition (I)}\label{tab:vdecnk1}')
    disp('\vspace{0.5\baselineskip}')
    disp('\begin{tabular}{lcccccc}')
    disp('\toprule')
    disp('&Output&Consumption & Investment & Hours & Inflation Rate & Nominal Interest Rate \\')
    disp('\midrule')
    for i=1:ne
        fprintf('&\\multicolumn{6}{c}{%s}\\\\ \n',model.shstr{i});
        for j=sel
            X   = 100*[vy{i}(:,j)./vty(:,j) vc{i}(:,j)./vtc(:,j) vx{i}(:,j)./vtx(:,j) vh{i}(:,j)./vth(:,j) vp{i}(:,j)./vtp(:,j) vr{i}(:,j)./vtr(:,j)];
            M   = median(X);
            P1  = prctile(X,pct);P1=P1(:)';
            P2  = prctile(X,100-pct);P2=P2(:)';
            P   = [P1;P2];
            P   = P(:)';
            fprintf(fmt1,j,M);
            fprintf(fmt2,P)
        end
        if i<ne;disp('\\');end
    end
    disp('\bottomrule')
    disp('\end{tabular}')
    disp(' ')
    disp('\parbox{\textwidth}{\footnotesize\underline{Note:} 66\% Confidence Interval into brackets}')
    disp('\end{table}')
else
    idx     = 1:4;
    vy  = cell(ne,1);
    vc  = cell(ne,1);
    vx  = cell(ne,1);
    vh  = cell(ne,1);
    for i=1:ne
        vy{i}   = zeros(N,nrep);
        vc{i}   = zeros(N,nrep);
        vx{i}   = zeros(N,nrep);
        vh{i}   = zeros(N,nrep);
    end
    vty = zeros(N,nrep);
    vtc = zeros(N,nrep);
    vtx = zeros(N,nrep);
    vth = zeros(N,nrep);
    for s=1:N
        sol     = feval(model.name,TH(s,:));
        for i=1:ne
            irf     = comp_irf(sol,i,nrep,sqrt(sol.sig(i,i)));
            irf     = irf.y.*(abs(irf.y)>1e-6);
            vy{i}(s,:)  = cumsum(irf(:,idx(1)).*irf(:,idx(1)))';
            vty(s,:)    = vty(s,:)+vy{i}(s,:);
            vc{i}(s,:)  = cumsum(irf(:,idx(2)).*irf(:,idx(2)))';
            vtc(s,:)    = vtc(s,:)+vc{i}(s,:);
            vx{i}(s,:)  = cumsum(irf(:,idx(3)).*irf(:,idx(3)))';
            vtx(s,:)    = vtx(s,:)+vx{i}(s,:);
            vh{i}(s,:)  = cumsum(irf(:,idx(4)).*irf(:,idx(4)))';
            vth(s,:)    = vth(s,:)+vh{i}(s,:);
        end
    end
    sel=[1 4 8 20 40];
    nsel=length(sel);
    fmt1= ['%2d ' repmat('& %5.2f ',1,4) '\\\\ \n'];
    fmt2= [repmat('& {\\scriptsize [%5.2f;%5.2f]} ',1,4) '\\\\ \n'];
    disp('\begin{table}[htbp]')
    disp('\centering')
    disp('\caption{Variance Decomposition (I)}\label{tab:vdecnk1}')
    disp('\vspace{0.5\baselineskip}')
    disp('\begin{tabular}{lcccc}')
    disp('\toprule')
    disp('&Output&Consumption & Investment & Hours \\')
    disp('\midrule')
    for i=1:ne
        fprintf('&\\multicolumn{4}{c}{%s}\\\\ \n',model.shstr{i});
        for j=sel
            X   = 100*[vy{i}(:,j)./vty(:,j) vc{i}(:,j)./vtc(:,j) vx{i}(:,j)./vtx(:,j) vh{i}(:,j)./vth(:,j)];
            M   = median(X);
            P1  = prctile(X,pct);P1=P1(:)';
            P2  = prctile(X,100-pct);P2=P2(:)';
            P   = [P1;P2];
            P   = P(:)';
            fprintf(fmt1,j,M);
            fprintf(fmt2,P)
        end
        if i<ne;disp('\\');end
    end
    disp('\bottomrule')
    disp('\end{tabular}')
    disp(' ')
    disp('\parbox{\textwidth}{\footnotesize\underline{Note:} 66\% Confidence Interval into brackets}')
    disp('\end{table}')
end
