function vdec_beliefs_model_mode(TH,model,nom_)
nrep    = 1000;
if nom_
    idx     = [1:4 6 7];
    str='&Output&Consumption & Investment & Hours & Inflation Rate & Nominal Interest Rate\\';
else
    idx     = 1:4;
    str='&Output&Consumption & Investment & Hours \\';
end
sel     =[1 4 8 20 40 1000];
sol     = feval(model.name,TH);
ne      = size(sol.me,2);
irf     = cell(ne,1);
vy      = cell(ne,1);
vtot    = 0;
for i=1:ne
    irf{i}  = comp_irf(sol,i,nrep,sqrt(sol.sig(i,i)));
    irf{i}.y= irf{i}.y.*(abs(irf{i}.y)>1e-6);
    vy{i}   = cumsum(irf{i}.y.*irf{i}.y);
    vtot    = vtot+vy{i};
end
disp('\begin{table}[htbp]')
disp('\centering')
disp('\caption{Variance Decomposition (I)}\label{tab:vdecnk1}')
disp('\vspace{0.5\baselineskip}')
disp('\begin{tabular}{lcccccc}')
disp('\toprule')
disp(str)
disp('\midrule')
for i=1:ne
    if nom_
        fprintf('&\\multicolumn{6}{c}{%s}\\\\ \n',model.shstr{i})
        fmt='%2d & %6.2f & %6.2f & %6.2f & %6.2f & %6.2f & %6.2f \\\\ \n';
    else
        fprintf('&\\multicolumn{4}{c}{%s}\\\\ \n',model.shstr{i})
        fmt='%2d & %6.2f & %6.2f & %6.2f & %6.2f \\\\ \n';
    end
    for j=sel
        M   = 100*vy{i}(j,idx)./vtot(j,idx);
        fprintf(fmt,j,M);
    end
    disp('\\')
end
disp('\bottomrule')
disp('\end{tabular}')
disp('\end{table}')
