function [VD,CY,CH,CI] = vdecfreq(solution,wmin,wmax,select)

grid    = 512;
om      = 0:(2*pi)/grid:(2*pi*(1-0.5/grid));
T       = length(om);
gain    = zeros(T,1);
gain(and(om>=wmin,om<=wmax))=1;
nsel    = length(select);
if solution.id==0
    MX      = solution.mx;
    MY      = solution.my;
    ME      = solution.me;
    SIG     = solution.sig;
    ne      = size(ME,2);
    im      = sqrt(-1);
    r2pi    = 1/(2*pi);
    Totfilt = [];
    filt    = cell(ne,1);
    VD      = zeros(nsel,ne);
    CY      = zeros(nsel,ne);
    CH      = zeros(nsel,ne);
    CI      = zeros(nsel,ne);
    CD      = cell(ne,1);
    for j=1:T;
        zi      = exp(-im*om(j));
        fom1    = MY(select,:)*((eye(length(MX))-MX*zi)\ME);
        fomT    = r2pi*(fom1*SIG*fom1');
        fomT    = gain(j)*fomT;
        Totfilt	= [Totfilt;fomT(:)'];
        for i=1:ne
            SS      = zeros(ne,ne);
            SS(i,i) = SIG(i,i);
            fomi    = r2pi*(fom1*SS*fom1');
            fomi    = gain(j)*fomi;
            filt{i}	= [filt{i};fomi(:)'];
        end
    end
    ACVT    = 2*pi*real(ifft(Totfilt));
    COVT    = reshape(ACVT(1,:),nsel,nsel);
    VTOT    = diag(COVT)';
    for i=1:ne
        ACVi    = 2*pi*real(ifft(filt{i}));
        COVi    = reshape(ACVi(1,:),nsel,nsel);
        VD(:,i) = 100*(diag(COVi)'./VTOT)';
        CY(:,i) = COVi(1,:)./abs(COVT(1,:));
        CI(:,i) = COVi(3,:)./abs(COVT(3,:));
        CH(:,i) = COVi(4,:)./abs(COVT(4,:));
    end
end

