function mod=vecmest(Y,lags,vcoint)
T       = length(Y);
DY      = Y(2:T,:)-Y(1:T-1,:);
Y       = Y(2:T,:);
[T,nvar]= size(Y);

rcoint  = Y(lags:T-1,:)*vcoint;
ncoint  = size(vcoint,2);

X       = zeros(T-lags,nvar*lags);
for i=1:lags;
    X(:,(i-1)*nvar+1:i*nvar)=DY(lags+1-i:T-i,:);
end
X       = [ones(size(X,1),1) rcoint X];
E       = zeros(T-lags,nvar);
MDY      = zeros(nvar,nvar*lags);
MC      = zeros(nvar*lags,1);
MR      = zeros(nvar*lags,ncoint);
for i=1:nvar
    b       = X\DY(lags+1:T,i);
    E(:,i)  = DY(lags+1:T,i)-X*b;
    MC(i,:) = b(1);
    MR(i,:) = b(2:ncoint+1)';
    MDY(i,:)= b(ncoint+2:nvar*lags+ncoint+1);
end
MV          = cell(lags+1,1);
k           = 1:nvar;
MV{1}       = eye(nvar)+MR(1:nvar,:)*vcoint'+MDY(:,k);
for p=2:lags
    k1      = (p-2)*nvar+1:(p-1)*nvar;
    k2      = (p-1)*nvar+1:p*nvar;
    MV{p}   = MDY(:,k2)-MDY(:,k1);
end
k           = (lags-1)*nvar+1:lags*nvar;
MV{lags+1}  =-MDY(:,k);
MDY         = [MDY;[eye(nvar*(lags-1)) zeros(nvar*(lags-1),nvar)]];
nx          = size(MDY,1);
MX          = [eye(nx)+MDY+[MR*vcoint' zeros(nx,nvar*(lags-1))] -MDY;eye(nx) zeros(nx)];

mod.lags    = lags;
mod.nvar    = nvar;
mod.mdy     = MDY;
mod.mc      = MR;
mod.mx      = MX;
mod.mvar    = MV;
mod.cst     = MC;
mod.vc      = vcoint;
mod.resid   = E;
mod.sigma   = cov(E);