% clear all
% clc
function sol=nk_model_utilization_ci_timing(param)

beta    = 0.99;
delta   = 0.025;
% exthp_  = 1;
rho     = 0.75;
mkup    = 0;
gsy     = 0.2;
ur      = 1-1e-6;
% param   = [0.5 0.5 0.5 0.5 0.5 0.5 1 1 1 1 1 1 1 1 0.5 0.5 0.3 2 0.5 ...
% 0.66 0.6 1.7 0.125 0.5 1];

ra      = param(1);
rn      = param(2);
ri      = param(3);
rc      = param(4);
rg      = param(5);
rx      = param(6);
seap    = param(7);
seat    = param(8);
sean    = param(9);
seip    = param(10);
seit    = param(11);
sec     = param(12);
seg     = param(13);
sex     = param(14);
psi     = param(15);
sigh    = param(16);
alpha   = param(17);
phi     = param(18);
b       = param(19);
xip     = param(20);
rhor    = param(21);
adp     = param(22);
ay      = param(23);
rm      = param(24);
sem     = param(25);
% rho     = param(26);
% Order of shocks
% Ap An At Ip It C G MP xi
% 1  2  3  4  5  6 7 8  9
R       = diag([ur,rn,ra,ur,ri,rc,rg,rm]);
R(1,2)  = 1;
Me      = eye(9);
SIG     = blkdiag(seap,sean,seat,seip,seit,sec,seg,sem,sex);

Q       = rx;
D       = [1;zeros(size(R,1)-1,1)];

ksy     = beta*alpha/((1+mkup)*(1-beta*(1-delta)));
isy     = delta*ksy;
csy     = 1-isy-gsy;

ny      = 4;
nb      = 7;
nf      = 20;

ne      = size(Me,1)-1;
nz      = size(Me,2);
Myy     = zeros(ny,ny);
Myx     = zeros(ny,nb);
MyX     = zeros(ny,nb);
MyY     = zeros(ny,ny);
Myf     = zeros(ny,nf);
MyF     = zeros(ny,nf);
Mys     = zeros(ny,ne);

Mxx0    = zeros(nb,nb);
Mxx1    = zeros(nb,nb);
MxX1    = zeros(nb,nb);
Mxy1    = zeros(nb,ny);
MxY1    = zeros(nb,ny);
Mxf1    = zeros(nb,nf);
MxF1    = zeros(nb,nf);
Mxs1    = zeros(nb,ne);

Mff0    = zeros(nf,nf);
Mff1    = zeros(nf,nf);
MfF0    = zeros(nf,nf);
MfF1    = zeros(nf,nf);
Mfx0    = zeros(nf,nb);
Mfx1    = zeros(nf,nb);
MfX1    = zeros(nf,nb);
Mfy0    = zeros(nf,ny);
Mfy1    = zeros(nf,ny);
MfY0    = zeros(nf,ny);
MfY1    = zeros(nf,ny);
Mfs0    = zeros(nf,ne);
Mfs1    = zeros(nf,ne);

% cf if c i
% 1  2  3 4
%
% kf cf(-1) if(-1) k c(-1) i(-1) R(-1)
% 1  2      3      4 5     6     7 
%
% yf hf uf lbf qf xif xkf y h u  s  lb q  xi xk R  dp G  
% 1  2  3  4   5  6   7   8 9 10 11 12 13 14 15 16 17 18
%
% SHOCKS:
% Ap An At Ip It C G MP
% 1  2  3  4  5  6 7 8
%
% Y vector
%
% Consumption (Flexible Price Allocation)
Myy(1,1)    = 1;
Myf(1,1)    = (1-rho)*(1-b);
MyF(1,1)    = rho*(1-b);
Myf(1,2)    =-(1-b)*(1+sigh);
Myx(1,2)    = b;
% Investment (Flexible Price Allocation)
Myy(2,1)    =-1;
Myy(2,2)    = (1-b)*phi*(1+beta);
Myx(2,2)    =-b;
Myf(2,6)    =-(1-b);
Myf(2,7)    = 1-b;
Mys(2,6)    =-b;
% Consumption
Myy(3,3)    = 1;
Myf(3,8)    = (1-rho)*(1-b);
MyF(3,8)    = rho*(1-b);
Myf(3,9)    =-(1-b)*(1+sigh);
Myf(3,11)   = 1-b;
Myx(3,5)    = b;
% Investment
Myy(4,3)    =-1;
Myy(4,4)    = (1-b)*phi*(1+beta);
Myx(4,5)    =-b;
Myf(4,14)   =-(1-b);
Myf(4,15)   = 1-b;
Mys(4,6)    =-(1-b);
%
% Xb vector
%
% Capital (Flexible Price Allocation)
Mxx0(1,1)   = 1;
Mxx1(1,1)   = 1-delta;
Mxy1(1,2)   = delta;
Mxs1(1,5)   = delta;
% Lagged Consumption (Flexible Price Allocation)
Mxx0(2,2)   = 1;
MxY1(2,1)   = 1;
% Lagged Investment (Flexible Price Allocation)
Mxx0(3,3)   = 1;
Mxy1(3,2)   = 1;
% Capital
Mxx0(4,4)   = 1;
Mxx1(4,4)   = 1-delta;
Mxy1(4,4)   = delta;
Mxs1(4,5)   = delta;
% Lagged Consumption
Mxx0(5,5)   = 1;
MxY1(5,3)   = 1;
% Lagged Investment
Mxx0(6,6)   = 1;
Mxy1(6,4)   = 1;
% Lagged Interest Rate
Mxx0(7,7)   = 1;
Mxf1(7,16)  = 1;
%
% Xf vector
%
% Output (Flexible Price Allocation)
Mff1(1,1)   = 1-rho;
MfF1(1,1)   = rho;
Mfy1(1,1)   =-csy;
Mfy1(1,2)   =-isy;
Mff1(1,3)   =-alpha;
Mff1(1,18)  =-gsy;
Mfs1(1,4)   =-isy;
% Hours worked (Flexible Price Allocation)
Mff1(2,1)   = 1;
Mff1(2,2)   = alpha-1;
Mff1(2,3)   =-alpha;
Mfx1(2,1)   =-alpha;
Mfs1(2,1)   =-1;
Mfs1(2,3)   =-1;
% Utilization (Flexible Price Allocation)
Mff1(3,1)   = (1-psi)*(1-rho);
Mff1(3,3)   =-1;
Mfx1(3,1)   =-(1-psi);
MfF1(3,1)   = (1-psi)*rho;
Mfs1(3,4)   =-(1-psi);
% Lambda (Flexible Price Allocation)
Mff1(4,4)   = 1;
Mfx1(4,2)   =-b/(1-b);
Mfy1(4,1)   = 1/(1-b);
Mfs1(4,6)   =-1;
% Tobin's Q (Flexible Price Allocation)
Mff1(5,5)   = 1;
Mff1(5,6)   =-1;
Mfy1(5,2)   =-phi*(1+beta);
% xi (Flexible Price Allocation)
Mff1(6,6)   = 1;
Mfx1(6,3)   = phi;
Mfy0(6,2)   = beta*phi;
Mfs1(6,4)   =-1;
Mfs1(6,5)   = 1;
% xk (Flexible Price Allocation)
Mff0(7,1)   = (1-beta*(1-delta))*(1-rho);
Mff0(7,3)   =-(1-beta*(1-delta));
Mff0(7,4)   = 1;
Mff0(7,5)   = beta*(1-delta);
Mff1(7,7)   = 1;
MfF0(7,1)   =-(1-beta*(1-delta))*rho;
Mfx0(7,1)   = 1-beta*(1-delta);
% Output 
Mff1(8,8)   = 1-rho;
MfF1(8,8)   = rho;
Mfy1(8,3)   =-csy;
Mfy1(8,4)   =-isy;
Mff1(8,10)  =-alpha;
Mff1(8,18)  =-gsy;
Mfs1(8,4)   =-isy;
% Hours worked
Mff1(9,8)   = 1;
Mff1(9,9)   = alpha-1;
Mff1(9,10)  =-alpha;
Mfx1(9,4)   =-alpha;
Mfs1(9,1)   =-1;
Mfs1(9,3)   =-1;
% Utilization
Mff1(10,8)   = (1-psi)*(1-rho);
MfF1(10,8)   = (1-psi)*rho;
Mff1(10,10)  =-1;
Mff1(10,11)  = (1-psi);
Mfx1(10,4)   =-(1-psi);
Mfs1(10,4)   =-(1-psi);
% Marginal Cost
Mff1(11,16)  = 1;
Mff1(11,1)   = (1-rhor)*ay;
Mff1(11,3)   =-(1-rhor)*ay*alpha;
Mff1(11,8)   =-(1-rhor)*ay;
Mff1(11,10)  = (1-rhor)*ay*alpha;
Mff1(11,17)  =-(1-rhor)*adp;
Mfx1(11,7)   =-rhor;
Mfs1(11,8)   =-1;
% Lambda 
Mff1(12,12)  = 1;
Mfx1(12,5)   =-b/(1-b);
Mfs1(12,6)   =-1;
Mfy1(12,3)   = 1/(1-b);
% Tobin's Q
Mff1(13,13)  = 1;
Mff1(13,14)  =-1;
Mfy1(13,4)   =-phi*(1+beta);
% xi
Mff1(14,14)  = 1;
Mfx1(14,6)   = phi;
Mfy0(14,4)   = beta*phi;
Mfs1(14,4)   =-1;
Mfs1(14,5)   = 1;
% xk
Mff0(15,8)   = (1-beta*(1-delta))*(1-rho);
MfF0(15,8)   =-(1-beta*(1-delta))*rho;
Mff0(15,10)  =-(1-beta*(1-delta));
Mff0(15,11)  = (1-beta*(1-delta));
Mff0(15,12)  = 1;
Mff0(15,13)  = beta*(1-delta);
Mff1(15,15)  = 1;
Mfx0(15,4)   = 1-beta*(1-delta);
% R
Mff0(16,12) = 1;
MfF0(16,17) = 1;
Mff1(16,8)  =-(1-rho);
Mff1(16,9)  = 1+sigh;
Mff1(16,11) =-1;
MfF1(16,8)  =-rho;
Mff1(16,16) =-1;
Mfs1(16,6)  = 1;
% dp
Mff0(17,17) = beta*xip;
Mff1(17,11) =-(1-xip)*(1-beta*xip);
Mff1(17,17) = 1-(1-xip)*(1-beta*xip);
MfF1(17,17) =-((1-xip)-(1-xip)*(1-beta*xip));
% Governement Spending
Mff1(18,18) = 1;
Mfs1(18,1)  =-1/(1-alpha);
Mfs1(18,4)  = alpha/(1-alpha);
Mfs1(18,7)  =-1;
% GDP
Mff1(19,19) = 1;
Mff1(19,8)  =-1;
Mff1(19,10) = alpha;
% Discounted sum of GDP
Mff0(20,20) = beta;
Mff1(20,19) =-1;
Mff1(20,20) = 1;
% Defining the model
%
model.myy   = Myy;
model.myx   = Myx;
model.myX   = MyX;
model.myY   = MyY;
model.myf   = Myf;
model.myF   = MyF;
model.mys   = Mys;

model.mxx0  = Mxx0;
model.mxx1  = Mxx1;
model.mxX1  = MxX1;
model.mxy1  = Mxy1;
model.mxY1  = MxY1;
model.mxf1  = Mxf1;
model.mxF1  = MxF1;
model.mxs1  = Mxs1;

model.mff0  = Mff0;
model.mff1  = Mff1;
model.mfF0  = MfF0;
model.mfF1  = MfF1;
model.mfy0  = Mfy0;
model.mfy1  = Mfy1;
model.mfY0  = MfY0;
model.mfY1  = MfY1;
model.mfx0  = Mfx0;
model.mfx1  = Mfx1;
model.mfX1  = MfX1;
model.mfs0  = Mfs0;
model.mfs1  = Mfs1;
model.r     = R;
model.q     = Q;
model.Delta = D;

% cf if c i yf hf uf lbf qf xif xkf y  h  u  s  lb q  xi xk R  dp G  
% 1  2  3 4 5  6  7  8   9  10  11  12 13 14 15 16 17 18 19 20 21 22
%
% kf cf(-1) if(-1) k c(-1) i(-1) R(-1) Ap An At Ip It C  G  MP xi
% 1  2      3      4 5     6     7     8  9  10 11 12 13 14 15 16
iyf	= 5;
icf = 1;
iif = 2;
ihf = 6;
iuf = 7;
iy  = 12;
ic  = 3;
ii  = 4;
ih  = 13;
iu  = 14;
is  = 15;
iR  = 20;
iRf = 23;
idp = 21;


sol = solve_beliefs(model,2);
% sol.my
% return
%
nx  = size(sol.mx,1);
Ix  = eye(nx);
if sol.id==0
    sol.me      = [zeros(nb,nz);Me];
    sol.sig     = SIG*SIG;
    dryf        = sol.my(iyf,:)-alpha*sol.my(iuf,:);
    drhf        = sol.my(ihf,:);
    drcf        = sol.my(icf,:);
    drif        = sol.my(iif,:)+Ix(11,:);
    drpf        = dryf-drhf;
    drc         = sol.my(ic,:);
    dri         = sol.my(ii,:)+Ix(11,:);
    drh         = sol.my(ih,:);
    dry         = sol.my(iy,:)-alpha*sol.my(iu,:);    
    drp         = dry-drh;
    dru         = sol.my(iu,:);
    drdp        = sol.my(idp,:);
    drR         = sol.my(iR,:);
    
    sol.my      = [dry;drc;dri;drh;dru;drdp;drR;drp;dryf;drcf;drif;drhf;drpf;sol.my(24,:)];
                  % 1   2   3   4   5   6    7   8   9    10   11   12   13  14
    if isfield(sol,'myf')
        for i=1:2
            sol.myf{i}  = sol.myf{i}(iy,:);
        end
    end
end
% [VD,CY,CH,CI] = vdecfreq(sol,2*pi/32,2*pi/6,[1:4 6 7]);
% ne      = 9;
% mvdsp   = reshape(VD(:),6,ne)';

% irf=comp_irf(sol,9,40);
% figure;
% subplot(221);h=plot(irf.y(:,[16 13 15 14]));title('R')
% legend('R^s','R^f','E_i R^s','E_i R^f')
% set(h(1),'color','b','linewidth',1.2)
% set(h(2),'color','r','linewidth',1.2)
% set(h(3),'color','b','linewidth',1.2,'linestyle','--')
% set(h(4),'color','r','linewidth',1.2,'linestyle','--')
% subplot(222);plot(irf.y(:,6));title('\pi')
% subplot(234);plot(irf.y(:,[2 9]));title('c')
% subplot(235);plot(irf.y(:,[3 10]));title('i')
% subplot(236);plot(irf.y(:,[4 11]));title('h')
% % return
