function sol=real_model_utilization_ci_timing_extras(param,ix,k)
% Utilization is chosen ex-ante
% param=fpth;
% ix=2;
% k=20;
beta    = 0.99;
delta   = 0.025;
rho     = 0.75;
mkup    = 0;
gsy     = 0.2;
ur      = 1-1e-6;

ra      = param(1);
rn      = param(2);
ri      = param(3);
rc      = param(4);
rg      = param(5);
rx      = param(6);
seap    = param(7);
seat    = param(8);
sean    = param(9);
seip    = param(10);
seit    = param(11);
sec     = param(12);
seg     = param(13);
sex     = param(14);
psi     = param(15);
sigh    = param(16);
alpha   = param(17);
phi     = param(18);
b       = param(19);
R       = diag([ur rn ra ur ri rc rg]);
R(1,2)  = 1;
SIG     = diag([seap sean seat seip seit sec seg sex]);
Me      = eye(8);

Q       = rx;
D       = [1;zeros(size(R,1)-1,1)];

ksy     = beta*alpha/((1+mkup)*(1-beta*(1-delta)));
isy     = delta*ksy;
csy     = 1-isy-gsy;

ny      = 3;
nb      = 3;
nf      = 11;
if k>1
    nf=nf+(k-1);
end
ne      = size(Me,1)-1;
nz      = size(Me,2);
Myy     = zeros(ny,ny);
Myx     = zeros(ny,nb);
MyX     = zeros(ny,nb);
MyY     = zeros(ny,ny);
Myf     = zeros(ny,nf);
MyF     = zeros(ny,nf);
Mys     = zeros(ny,ne);

Mxx0    = zeros(nb,nb);
Mxx1    = zeros(nb,nb);
MxX1    = zeros(nb,nb);
Mxy1    = zeros(nb,ny);
MxY1    = zeros(nb,ny);
Mxf1    = zeros(nb,nf);
MxF1    = zeros(nb,nf);
Mxs1    = zeros(nb,ne);

Mff0    = zeros(nf,nf);
Mff1    = zeros(nf,nf);
MfF0    = zeros(nf,nf);
MfF1    = zeros(nf,nf);
Mfx0    = zeros(nf,nb);
Mfx1    = zeros(nf,nb);
MfX1    = zeros(nf,nb);
Mfy0    = zeros(nf,ny);
Mfy1    = zeros(nf,ny);
MfY0    = zeros(nf,ny);
MfY1    = zeros(nf,ny);
Mfs0    = zeros(nf,ne);
Mfs1    = zeros(nf,ne);


% c i
% 1 2
%
% k c(-1) i(-1) b
% 1 2     3     4
%
% y h u lb q xc xi xk G x
% 1 2 3 4  5 6  7  8  9 1-
%
% SHOCKS:
% Ap An At Ip It C G
% 1  2  3  4  5  6 7
% Consumption
Myy(1,1)    = 1/(1-b);
Myf(1,1)    = (1-rho);
Myf(1,2)    =-(1+sigh);
Myf(1,6)    = 1;
MyF(1,1)    = rho;
Mys(1,6)    =-1;
% Investment
Myy(2,1)    =-1;
Myy(2,2)    = (1-b)*phi*(1+beta);
Myf(2,6)    =-(1-b);
Myf(2,7)    =-(1-b);
Myf(2,8)    = 1-b;
% E_it(x_{t+k})
Myy(3,3)    = 1;
Myf(3,nf)   = 1;
% Capital
Mxx0(1,1)   = 1;
Mxx1(1,1)   = 1-delta;
Mxy1(1,2)   = delta;
Mxs1(1,5)   = delta;
% Lagged Consumption
Mxx0(2,2)   = 1;
MxY1(2,1)   = 1;
% Lagged Investment
Mxx0(3,3)   = 1;
Mxy1(3,2)   = 1;
% Output
Mff1(1,1)   = 1-rho;
MfF1(1,1)   = rho;
Mfy1(1,1)   =-csy;
Mfy1(1,2)   =-isy;
Mff1(1,3)   =-alpha;
Mff1(1,9)   =-gsy;
Mfs1(1,4)   =-isy;
% Hours worked
Mff1(2,1)   = 1;
Mff1(2,2)   = alpha-1;
Mff1(2,3)   =-alpha;
Mfx1(2,1)   =-alpha;
Mfs1(2,1)   =-1;
Mfs1(2,3)   =-1;
% Utilization
Mff1(3,1)   = (1-psi)*(1-rho);
MfF1(3,1)   = (1-psi)*rho;
Mff1(3,3)   =-1;
Mfx1(3,1)   =-(1-psi);
Mfs1(3,4)   =-(1-psi);
% Lambda
Mff1(4,4)   = 1;
Mff1(4,6)   =-1;
Mfy1(4,1)   = 1/(1-b);
% Tobin's Q
Mff1(5,5)   = 1;
Mff1(5,7)   =-1;
Mfy1(5,2)   =-phi*(1+beta);
% xc
Mff1(6,6)   = 1;
Mfx1(6,2)   =-b/(1-b);
Mfs1(6,6)   =-1;
% xi
Mff1(7,7)   = 1;
Mfx1(7,3)   = phi;
Mfy0(7,2)   = beta*phi;
Mfs1(7,4)   =-1; %%%%%%%%%%%%%
Mfs1(7,5)   = 1;
% xk
Mff0(8,1)   = (1-beta*(1-delta))*(1-rho);
Mff0(8,3)   =-(1-beta*(1-delta));
Mff0(8,4)   = 1;
Mff0(8,5)   = beta*(1-delta);
Mff1(8,8)   = 1;
MfF0(8,1)   =-(1-beta*(1-delta))*rho;
Mfx0(8,1)   = 1-beta*(1-delta);
% Governement Spending
Mff1(9,9)  = 1;
Mfs1(9,1)  =-1/(1-alpha);
Mfs1(9,4)  = alpha/(1-alpha);
Mfs1(9,7)  =-1;
% C+Y+G
Mff1(10,10) = 1;
Mff1(10,1)  =-1;
Mff1(10,3)  = alpha;
% E_t(x_{t+k})
if k==0
    Mff1(11,11) = 1;
    Mff1(11,ix) =-1;
elseif k==1
    Mff1(11,11) = 1;
    Mff0(11,ix) = 1;
else
    Mff1(11,11) = 1;
    Mff0(11,ix) = 1;
    for i=2:k
        Mff1(10+i,10+i)=1;
        Mff0(10+i,10+(i-1))=1;
    end
end
% Defining the model
%
model.myy   = Myy;
model.myx   = Myx;
model.myX   = MyX;
model.myY   = MyY;
model.myf   = Myf;
model.myF   = MyF;
model.mys   = Mys;

model.mxx0  = Mxx0;
model.mxx1  = Mxx1;
model.mxX1  = MxX1;
model.mxy1  = Mxy1;
model.mxY1  = MxY1;
model.mxf1  = Mxf1;
model.mxF1  = MxF1;
model.mxs1  = Mxs1;

model.mff0  = Mff0;
model.mff1  = Mff1;
model.mfF0  = MfF0;
model.mfF1  = MfF1;
model.mfy0  = Mfy0;
model.mfy1  = Mfy1;
model.mfY0  = MfY0;
model.mfY1  = MfY1;
model.mfx0  = Mfx0;
model.mfx1  = Mfx1;
model.mfX1  = MfX1;
model.mfs0  = Mfs0;
model.mfs1  = Mfs1;
model.r     = R;
model.q     = Q;
model.Delta = D;

% c i Ei(x{t+k}) y h u lb q xi xk I  G
% 1 2 3          4 5 6 7  8 9  10 11 12
iy          = 4;
ic          = 1;
ix          = 2;
ih          = 5;
iu          = 6;
ig          = 12;
sol         = solve_beliefs(model,2);

if sol.id==0
    sol.me      = [zeros(nb,nz);Me];
    sol.sig     = SIG*SIG;
    I           = eye(size(sol.mx,1));
    drh         = sol.my(ih,:);
    drc         = sol.my(ic,:);
    dri         = sol.my(ix,:)+I(7,:);
    dry         = sol.my(iy,:)-alpha*sol.my(iu,:);
    drtfp       = sol.my(iy,:)-alpha*I(1,:)-(1-alpha)*sol.my(ih,:);
%     drq         = sol.my(iq,:);
%     drw         = sol.my(iw,:);
    drrr        = sol.my(1,:)-sol.my(1,:)*sol.mx;
    drysh       = dry-drh;
    dru         = sol.my(iu,:);
    drg         = sol.my(ig,:);
    
    sol.my      = [dry;drc;dri;drh;sol.my(3,:);drysh;drtfp;drrr;drg;dru;sol.my(end,:)];
%                  1   2   3   4   5     6     7     8
    if isfield(sol,'myf')
        for i=1:2
            sol.myf{i}  = sol.myf{i}(iy,:);
        end
    end

end
