addpath('method');
addpath('models');
nchain      = 2;
NDraws      = 200000;
step        = 20;
spmodel     = 'nk_model_utilization_ci_timing';
fpmodel     = 'real_model_utilization_ci_timing';
wmin        = 2*pi/32;
wmax        = 2*pi/6;
%% Sticky Price
filemetro   = 'results/metro_nk_ci_timing_';
TH          = zeros(nchain*NDraws,25);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
mTH = median(TH(1:step:end,:));
sels= [1 3 4 2 8 6 7];
nsel= length(sels);
sol         = feval(spmodel,mTH);
mom   = comp_mombp(sol,sels);
msdsp = mom.std;
mcysp = mom.cor(1,2:nsel);
mcisp = mom.cor(2,3:nsel);
mchsp = mom.cor(3,4:nsel);
%% Flexible Price
filemetro   = 'results/metro_real_util_ci';
TH          = zeros(nchain*NDraws,19);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
mTH  = median(TH(1:step:end,:));
self    = [1 3 4 2 5];
nsel    = length(self);
sol         = feval(fpmodel,mTH);
mom         = comp_mombp(sol,self);
msdfp = mom.std;
mcyfp = mom.cor(1,2:nsel);
mcifp = mom.cor(2,3:nsel);
mchfp = mom.cor(3,4:nsel);
%%
% save mom_beliefs STDsp CORYsp CORIsp CORHsp STDfp CORYfp CORIfp CORHfp
%% Table
for i=1:7
    if i<=5
        fprintf('%6.2f & %6.2f \n',msdfp(i),msdsp(i))
    else
        fprintf('   --  & %6.2f \n',msdsp(i))
    end
end
disp(' ')
for i=1:6
    if i<=4
        fprintf('%6.2f & %6.2f \n',mcyfp(i),mcysp(i))
    else
        fprintf('   --  & %6.2f \n',mcysp(i))
    end
end
disp(' ')
for i=1:5
    if i<=3
        fprintf('%6.2f & %6.2f \n',mcifp(i),mcisp(i))
    else
        fprintf('   --  & %6.2f \n',mcisp(i))
    end
end
disp(' ')
for i=1:4
    if i<=2
        fprintf('%6.2f & %6.2f \n',mchfp(i),mchsp(i))
    else
        fprintf('   --  & %6.2f \n',mchsp(i))
    end
end

